/* $Id: op_mkdir.c,v 1.2 2006/01/22 17:38:25 lace Exp $
 * Client fuse interface operation "mkdir" for libcaptive
 * Copyright (C) 2005 Jan Kratochvil <project-captive@jankratochvil.net>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; exactly version 2 of June 1991 is required
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include "config.h"

#include <glib/gmessages.h>
#include <fuse.h>
#include <errno.h>
#include <captive/client-directory.h>
#include <sys/stat.h>

#include "op_mkdir.h"	/* self */
#include "main.h"
#include "gnomevfsresult.h"
#include "utf8.h"


int op_mkdir(const char *path,mode_t mode)
{
CaptiveDirectoryObject *captive_directory_object;
GnomeVFSResult errvfsresult;

	g_return_val_if_fail(path!=NULL,-EINVAL);

	/* Do not: if (!S_ISDIR(mode))
	 * as FUSE does not set it.
	 */
	if (mode&S_IFMT)
		return -EPERM;

  path=CAPFUSE_FILENAME_TO_UTF8_ALLOCA(path);

	if (GNOME_VFS_OK!=(errvfsresult=captive_directory_new_make(&captive_directory_object,capfuse_captive_vfs_object,
				path,	/* pathname */
				mode)))	/* perm */
		return -gnomevfsresult_to_errno(errvfsresult);

	g_object_unref(captive_directory_object);

	return 0;
}
