/* $Id: op_unlink.c,v 1.2 2006/01/22 17:38:25 lace Exp $
 * Client fuse interface operation "unlink" for libcaptive
 * Copyright (C) 2005 Jan Kratochvil <project-captive@jankratochvil.net>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; exactly version 2 of June 1991 is required
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include "config.h"

#include <glib/gmessages.h>
#include <fuse.h>
#include <errno.h>
#include <captive/client-file.h>
#include <captive/macros.h>

#include "op_unlink.h"	/* self */
#include "main.h"
#include "gnomevfsresult.h"
#include "utf8.h"


int op_unlink(const char *path)
{
CaptiveFileObject *captive_file_object;
GnomeVFSResult errvfsresult;

	g_return_val_if_fail(path!=NULL,-EINVAL);

  path=CAPFUSE_FILENAME_TO_UTF8_ALLOCA(path);

	if (GNOME_VFS_OK!=(errvfsresult=captive_file_new_open(&captive_file_object,capfuse_captive_vfs_object,path,
			GNOME_VFS_OPEN_WRITE|GNOME_VFS_OPEN_RANDOM)))
		return -gnomevfsresult_to_errno(errvfsresult);

	errvfsresult=captive_file_remove(captive_file_object);

	g_object_unref(captive_file_object);

	if (GNOME_VFS_OK!=errvfsresult)
		return -gnomevfsresult_to_errno(errvfsresult);
	return 0;
}
