/* $Id: file-slave.h,v 1.1 2003/09/09 17:27:28 short Exp $
 * Include file for captive vfs 'file' private interface to reactos of sandbox slave
 * Copyright (C) 2003 Jan Kratochvil <project-captive@jankratochvil.net>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; exactly version 2 of June 1991 is required
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#ifndef _CAPTIVE_CLIENT_PRIV_FILE_SLAVE_H
#define _CAPTIVE_CLIENT_PRIV_FILE_SLAVE_H 1


#include <glib/gmacros.h>
#include <glib/gtypes.h>
#include <glib-object.h>
#include <libgnomevfs/gnome-vfs-result.h>
#include "captive/client-file.h"


G_BEGIN_DECLS

#define CAPTIVE_FILE_SLAVE_TYPE_OBJECT            (captive_file_slave_object_get_type())
#define CAPTIVE_FILE_SLAVE_OBJECT(object)         (G_TYPE_CHECK_INSTANCE_CAST((object),CAPTIVE_FILE_SLAVE_TYPE_OBJECT,CaptiveFileSlaveObject))
#define CAPTIVE_FILE_SLAVE_OBJECT_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),CAPTIVE_FILE_SLAVE_TYPE_OBJECT,CaptiveFileSlaveObjectClass))
#define CAPTIVE_FILE_SLAVE_IS_OBJECT(object)      (G_TYPE_CHECK_INSTANCE_TYPE((object),CAPTIVE_FILE_SLAVE_TYPE_OBJECT))
#define CAPTIVE_FILE_SLAVE_IS_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),CAPTIVE_FILE_SLAVE_TYPE_OBJECT))
#define CAPTIVE_FILE_SLAVE_OBJECT_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),CAPTIVE_FILE_SLAVE_TYPE_OBJECT,CaptiveFileSlaveObjectClass))
typedef struct _CaptiveFileSlaveObject      CaptiveFileSlaveObject;
typedef struct _CaptiveFileSlaveObjectClass CaptiveFileSlaveObjectClass;


GType captive_file_slave_object_get_type(void);

GnomeVFSResult captive_file_slave_new_open(CaptiveFileObject **captive_file_object_return,
		CaptiveVfsObject *captive_vfs_object,const gchar *pathname,GnomeVFSOpenMode mode);
GnomeVFSResult captive_file_slave_new_create(CaptiveFileObject **captive_file_object_return,
		CaptiveVfsObject *captive_vfs_object,const gchar *pathname,GnomeVFSOpenMode mode,gboolean exclusive,guint perm);

G_END_DECLS


#endif /* _CAPTIVE_CLIENT_PRIV_FILE_SLAVE_H */
