/* $Id: giochannel-blind.h,v 1.7 2003/12/06 14:04:54 short Exp $
 * Include file for glib r/w GIOChannel buffered-over r/o GIOChannel for libcaptive
 * Copyright (C) 2003 Jan Kratochvil <project-captive@jankratochvil.net>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; exactly version 2 of June 1991 is required
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#ifndef _CAPTIVE_GNOMEVFS_GIOCHANNEL_BLIND_H
#define _CAPTIVE_GNOMEVFS_GIOCHANNEL_BLIND_H 1


#include <glib/giochannel.h>
#include <libxml/tree.h>
#ifdef HAVE_LIBXML_BUFFERING
#include <libxml/xmlreader.h>
#endif


G_BEGIN_DECLS

struct captive_giochannel_blind;

struct captive_giochannel_blind *captive_giochannel_blind_new(GIOChannel *giochannel_ro,gboolean writeable);
gboolean captive_giochannel_blind_get_size(GIOChannel *giochannel,guint64 *size_return);
GIOStatus captive_giochannel_blind_commit(GIOChannel *giochannel_blind);
xmlNode *captive_giochannel_blind_readreport_to_xml(xmlNode *xml_parent,GIOChannel *giochannel);
#ifdef HAVE_LIBXML_BUFFERING
struct captive_giochannel_blind *captive_giochannel_blind_new_from_xml(xmlTextReader *xml_reader);
#endif

G_END_DECLS


#endif /* _CAPTIVE_GNOMEVFS_GIOCHANNEL_BLIND_H */
