/* $Id: stream.c,v 1.1 2002/12/12 04:04:18 short Exp $
 * reactos stream handling functions emulation of libcaptive
 * Copyright (C) 2002 Jan Kratochvil <project-captive@jankratochvil.net>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; exactly version 2 of June 1991 is required
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include "config.h"

/* FIXME: #include missing prototype */	/* self */
#include <glib/gmessages.h>
#include "reactos/ntos/types.h"	/* for VOID */
#include "reactos/ddk/ntifs.h"	/* for PFSRTL_ADVANCED_FCB_HEADER */


/**
 * FsRtlTeardownPerStreamContexts:
 * @AdvancedHeader: Registry of all filter contexts.
 * %NULL value is forbidden.
 *
 * Frees all filter contexts for @AdvancedHeader.
 * Currently a nop for libcaptive as it does not support any filter drivers.
 */
VOID FsRtlTeardownPerStreamContexts(IN PFSRTL_ADVANCED_FCB_HEADER AdvancedHeader)
{
	g_return_if_fail(AdvancedHeader!=NULL);

	/* NOP */
}
