/* $Id: spinlock.c,v 1.3 2003/01/16 03:46:21 short Exp $
 * reactos spinlock emulation of libcaptive
 * Copyright (C) 2002 Jan Kratochvil <project-captive@jankratochvil.net>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; exactly version 2 of June 1991 is required
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include "config.h"

#include "reactos/ddk/kefuncs.h"	/* self */


/**
 * KeAcquireSpinLockAtDpcLevel:
 * @SpinLock: Spinlock to acquire
 *
 * Acquires a spinlock if the caller already runs on >= %DISPATCH_LEVEL.
 * Currently libcaptive doesn't use multithreading
 * and thus this function is a NOP now. #GMutex would be needed otherwise.
 */
VOID KeAcquireSpinLockAtDpcLevel(PKSPIN_LOCK SpinLock)
{
	/* TODO:thread */
}


/**
 * KeReleaseSpinLockFromDpcLevel:
 * @SpinLock: Spinlock to release
 *
 * Releases a spinlock if the caller already run on >= %DISPATCH_LEVEL
 * during its acquire by KeAcquireSpinLockAtDpcLevel().
 * Currently libcaptive doesn't use multithreading
 * and thus this function is a NOP now. #GMutex would be needed otherwise.
 */
VOID KeReleaseSpinLockFromDpcLevel(PKSPIN_LOCK SpinLock)
{
	/* TODO:thread */
}
