/* $Id: apc.c,v 1.1 2003/01/16 04:00:36 short Exp $
 * reactos APC functions emulation of libcaptive
 * Copyright (C) 2002 Jan Kratochvil <project-captive@jankratochvil.net>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; exactly version 2 of June 1991 is required
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include "config.h"

#include <glib/gmessages.h>
#include "reactos/ddk/kefuncs.h"	/* for KeGetCurrentThread() */
#include "reactos/internal/ps.h"	/* for KTHREAD */


/**
 * KeAreApcsDisabled:
 *
 * Detects whether KeGetCurrentThread() structure has APCs disabled.
 *
 * Returns: %TRUE if APCs are currently disabled.
 */
BOOLEAN KeAreApcsDisabled(VOID)
{
	g_assert(KeGetCurrentThread()->KernelApcDisable>=0);

	return KeGetCurrentThread()->KernelApcDisable!=0;
}
