/* $Id: server-File.h,v 1.2 2003/05/04 12:03:33 short Exp $
 * Include file for CORBA/ORBit server side of File object
 * Copyright (C) 2003 Jan Kratochvil <project-captive@jankratochvil.net>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; exactly version 2 of June 1991 is required
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#ifndef _SERVER_FILE_H
#define _SERVER_FILE_H 1


#include <glib/gmacros.h>
#include "sandbox.h"
#include "captive/client-file.h"
#include "server-Vfs.h"


G_BEGIN_DECLS

typedef struct {
	POA_Captive_File servant;
	PortableServer_POA poa;
	CaptiveFileObject *captive_file_object;
	} impl_POA_Captive_File;


Captive_File impl_Captive_File__create(PortableServer_POA poa,CORBA_Environment *ev);
Captive_File impl_Captive_Vfs_file_new_open
		(impl_POA_Captive_Vfs *servant,const CORBA_char *pathname,const Captive_GnomeVFSOpenMode mode,CORBA_Environment *ev);
Captive_File impl_Captive_Vfs_file_new_create(impl_POA_Captive_Vfs *servant,const CORBA_char *pathname,
		const Captive_GnomeVFSOpenMode mode,const CORBA_boolean exclusive,const CORBA_unsigned_long perm,CORBA_Environment *ev);

G_END_DECLS


#endif /* _SERVER_FILE_H */
